// Code generated by Kitex v1.9.1. DO NOT EDIT.

package studentservice

import (
	"code.byted.org/kite/kitex/byted"
	"code.byted.org/kite/kitex/client"
	"code.byted.org/kite/kitex/client/callopt"
	"code.byted.org/kitex/example_student/kitex_gen/kitex/example/student"
	"context"
)

// Client is designed to provide IDL-compatible methods with call-option parameter for kitex framework.
type Client interface {
	GetStudentById(ctx context.Context, req *student.GetStudentByIdRequest, callOptions ...callopt.Option) (r *student.GetStudentByIdResponse, err error)
	InsertStudent(ctx context.Context, req *student.InsertStudentRequest, callOptions ...callopt.Option) (r *student.InsertStudentResponse, err error)
	UpdateStudent(ctx context.Context, req *student.UpdateStudentRequest, callOptions ...callopt.Option) (r *student.UpdateStudentResponse, err error)
	DeleteStudentById(ctx context.Context, req *student.DeleteStudentByIdRequest, callOptions ...callopt.Option) (r *student.DeleteStudentByIdResponse, err error)
}

// NewClient creates a client for the service defined in IDL.
func NewClient(destService string, opts ...client.Option) (Client, error) {
	var options []client.Option
	options = append(options, client.WithDestService(destService))

	config := byted.NewClientConfig()
	config.DestService = destService

	options = append(options, byted.ClientSuiteWithConfig(serviceInfo(), config))

	options = append(options, opts...)

	kc, err := client.NewClient(serviceInfo(), options...)
	if err != nil {
		return nil, err
	}
	return &kStudentServiceClient{
		kClient: newServiceClient(kc),
	}, nil
}

// MustNewClient creates a client for the service defined in IDL. It panics if any error occurs.
func MustNewClient(destService string, opts ...client.Option) Client {
	kc, err := NewClient(destService, opts...)
	if err != nil {
		panic(err)
	}
	return kc
}

type kStudentServiceClient struct {
	*kClient
}

func (p *kStudentServiceClient) GetStudentById(ctx context.Context, req *student.GetStudentByIdRequest, callOptions ...callopt.Option) (r *student.GetStudentByIdResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetStudentById(ctx, req)
}

func (p *kStudentServiceClient) InsertStudent(ctx context.Context, req *student.InsertStudentRequest, callOptions ...callopt.Option) (r *student.InsertStudentResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.InsertStudent(ctx, req)
}

func (p *kStudentServiceClient) UpdateStudent(ctx context.Context, req *student.UpdateStudentRequest, callOptions ...callopt.Option) (r *student.UpdateStudentResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateStudent(ctx, req)
}

func (p *kStudentServiceClient) DeleteStudentById(ctx context.Context, req *student.DeleteStudentByIdRequest, callOptions ...callopt.Option) (r *student.DeleteStudentByIdResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.DeleteStudentById(ctx, req)
}

// NewClientWithBytedConfig creates a client for the service defined in IDL.
func NewClientWithBytedConfig(destService string, config *byted.ClientConfig, opts ...client.Option) (Client, error) {
	if config == nil {
		config = byted.NewClientConfig()
	}
	config.DestService = destService

	var options []client.Option
	options = append(options, client.WithDestService(destService))

	options = append(options, byted.ClientSuiteWithConfig(serviceInfo(), config))
	options = append(options, opts...)
	kc, err := client.NewClient(serviceInfo(), options...)
	if err != nil {
		return nil, err
	}
	return &kStudentServiceClient{
		kClient: newServiceClient(kc),
	}, nil
}

// MustNewClientWithBytedConfig creates a client for the service defined in IDL. It panics if any error occurs.
func MustNewClientWithBytedConfig(destService string, config *byted.ClientConfig, opts ...client.Option) Client {
	kc, err := NewClientWithBytedConfig(destService, config, opts...)
	if err != nil {
		panic(err)
	}
	return kc
}
